# -*- coding: utf-8 -*-
# Moovida - Home multimedia server
# Copyright (C) 2006-2009 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 3.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Moovida with Fluendo's plugins.
#
# The GPL part of Moovida is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Moovida" in the root directory of this distribution package
# for details on that license.
#
# Author: Fernando Casanova <fcasanova@fluendo.com>

DEBUG_LEVEL = 1

class Loggable(object):

    def __init__(self, **kw):
        super(Loggable, self).__init__(**kw)

    def display(self, header, message, minimum_log_level):
        if DEBUG_LEVEL > minimum_log_level:
            print '[%s] %s' % (header, message)


    def debug(self, message):
        self.display('DEBUG', message, 3)

    def info(self, message):
        self.display('INFO', message, 2)

    def warning(self, message):
        self.display('WARNING', message, 1)

    def error(self, message):
        self.display('ERROR', message, 0)
