# -*- coding: utf-8 -*-
# Moovida - Home multimedia server
# Copyright (C) 2006-2009 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 3.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Moovida with Fluendo's plugins.
#
# The GPL part of Moovida is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Moovida" in the root directory of this distribution package
# for details on that license.
#
# Author: Guillaume Emont <guillaume@fluendo.com>

class Merger(object):
    def __init__(self, manager=None, **kw):
        super(Merger, self).__init__(**kw)
        self.manager = manager

    def merge_statements(self, statements, source):
        """
        Merge the statements obtained from source, where it makes sense, into
        the cache of C{self.manager}

        @param statements: statements candidate for merging
        @type  statements: iterable of C{RDF.Statement}
        @param source: the source where statements come from
        @type  source: C{data_source.MetadataSource}
        """
        raise NotImplementedError()

