# -*- coding: utf-8 -*-
# Moovida - Home multimedia server
# Copyright (C) 2006-2009 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 3.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Moovida with Fluendo's plugins.
#
# The GPL part of Moovida is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Moovida" in the root directory of this distribution package
# for details on that license.
#
# Author: Fernando Casanova <fcasanova@fluendo.com>

import time

class Statistics(object):
    def __init__(self):
        self.start_time = time.time()
        self.mean_time = 0
        self.before_time = {}

        self.success = 0
        self.failure = 0
        self.total = 0
        self.total_time = 0

        self.failures = []

    def start_treating_one(self, uri):
        self.before_time[uri] = time.time()

    def finished_treating_one(self, success, uri):
        if success:
            self.success += 1
        else:
            self.failure += 1
            self.failures.append(uri)

        self.total += 1

        after_time = time.time()
        time_for_one_item = after_time - self.before_time[uri]
        self.total_time = after_time - self.start_time
        self.mean_time = ((self.total - 1.0) * self.mean_time + time_for_one_item) / self.total

    def print_results(self):
        print "MEAN %s TOTAL %s MEANMEAN %s" % (self.mean_time, self.total_time, self.total_time/self.total)
        print "SUCCESS %s FAILURE %s TOTAL %s" % (self.success, self.failure, self.total)
        print "FAILURES:"
        for failure in self.failures:
            print failure
