
import time
from extern.queue import CancellableQueue
from twisted.internet import reactor, defer
from twisted.web.client import getPage

def getDummyData(args):
    dfr = defer.Deferred()
    reactor.callLater(args, mock_fct, dfr, args)
    return dfr

def mock_fct(dfr, args):
    print "CALLED!! %s %s" % (args, time.time())
    if args % 4 == 2:
        dfr.errback(Exception('GRUUUUU'))
    else:
        dfr.callback(args*3)
    return dfr

def treat_result(result):
    print "RETURNED WITH RESULT %s" % result
    return result

def treat_result_err(failure):
    print "FAILED !!! %s" % failure
    import pdb; pdb.set_trace()
    #return failure

def test_enqueue_simple():
    print "==========================="
    print ">>> test_enqueue_simple <<<"
    dfr = getPage('http://www.thetvdb.com/api/GetSeries.php?seriesname=next%20day%20air', timeout=0)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    return dfr


def test_enqueue_simple2():
    print "==========================="
    print ">>> test_enqueue_simple <<<"
    myQueue = CancellableQueue(2)
    dfr = myQueue.enqueue(getDummyData, 3)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    return dfr

def test_enqueue_error(result):
    print "==========================="
    print ">>> test_enqueue_error <<<"
    myQueue = CancellableQueue(2)
    dfr = myQueue.enqueue(getDummyData, 2)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    return dfr

def test_enqueue_multiple(result):
    print "============================="
    print ">>> test_enqueue_multiple <<<"
    myQueue = CancellableQueue(2)
    dfr = myQueue.enqueue(getDummyData, 3)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    dfr = myQueue.enqueue(getDummyData, 4)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    dfr = myQueue.enqueue(getDummyData, 5)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    dfr = myQueue.enqueue(getDummyData, 6)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    dfr = myQueue.enqueue(getDummyData, 7)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    dfr = myQueue.enqueue(getDummyData, 8)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    dfr = myQueue.enqueue(getDummyData, 9)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)
    dfr = myQueue.enqueue(getDummyData, 10)
    dfr.addCallback(treat_result)
    dfr.addErrback(treat_result_err)

def process():
    dfr = test_enqueue_simple()
    dfr.addCallback(test_enqueue_error)
    dfr.addCallback(test_enqueue_multiple)

if __name__ == '__main__':
    def run():
        reactor.callWhenRunning(process)
        reactor.run()
    run()

