# -*- coding: utf-8 -*-
# Moovida - Home multimedia server
# Copyright (C) 2006-2009 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 3.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Moovida with Fluendo's plugins.
#
# The GPL part of Moovida is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Moovida" in the root directory of this distribution package
# for details on that license.
#
# Author: Fernando Casanova <fcasanova@fluendo.com>

import sys

from twisted.internet import reactor

from core.media_scanner.media_scanner_ng import MediaScanner
from core.media_scanner.metadata_manager import MetadataManager, Merger

import core.log

from plugins.themoviedb.metadata_source import TheMovieDBDataSource

def finish_scanning(result):
    print "FINISH!!"
    reactor.stop()

class SimpleMerger(Merger):
    """Merge everything, without any check."""
    def merge_statements(self, statements, source):
        self.manager.add_statements(*statements)
        return defer.succeed(None)


def process(args):
    base_uri = ""
    verbose = ""

    base_uri = args[0]

    core.log.DEBUG_LEVEL = 4


    metadata_manager = MetadataManager()
    media_scanner = MediaScanner(metadata_manager)

    data_source = TheMovieDBDataSource(manager=metadata_manager)
    metadata_manager.add_source(data_source, SimpleMerger(manager=metadata_manager))

    dfr = media_scanner.scan_dir(base_uri)
    dfr.addCallback(finish_scanning)


if __name__ == '__main__':
    def run(iargs):
        reactor.callWhenRunning(process, iargs)
        reactor.run()
    run(sys.argv[1:])
