<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
     xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"
     version = "1.0" >
<!-- Output method XML -->
<!-- xmlns:fn="http://www.w3.org/2005/xpath-functions" -->
<xsl:output method="xml"
      indent="yes"
      omit-xml-declaration="no"
      encoding="utf-8"  />
  <xsl:template match="/">
    <rdf:RDF>
    <xsl:for-each select="plist/dict/dict/dict">
       <xsl:sort select="key[. = 'Name']/following-sibling::*/text()"/>
       <xsl:sort select="key[. = 'Artist']/following-sibling::*/text()"/>
       <xsl:sort select="key[. = 'Album']/following-sibling::*/text()"/>

	   <xsl:if test="key[. = 'Has Video'] and key[. = 'Movie']">
         <!-- We have a movie! -->
         <xsl:variable name="file">
           <xsl:apply-templates select="key[. = 'Location']" mode="location"/>
         </xsl:variable>
         <xsl:variable name="label" select="key[. = 'Name']/following-sibling::*/text()"/>
         <rdf:Description rdf:about="{$file}">
           <rdfs:label><xsl:value-of select = "$label" /></rdfs:label>
         </rdf:Description>
         <rdf:Description rdf:about="{$file}">
           <rdfs:type>movie</rdfs:type>
         </rdf:Description>
       </xsl:if>
       <xsl:if test="key[. = 'Has Video'] and key[. = 'TV Show']">
         <!-- We have a TV episode! -->
         <xsl:variable name="file">
           <xsl:apply-templates select="key[. = 'Location']" mode="location"/>
         </xsl:variable>
         <xsl:variable name="label" select="key[. = 'Name']/following-sibling::*/text()"/>
         <rdf:Description rdf:about="{$file}">
           <rdfs:label><xsl:value-of select = "$label" /></rdfs:label>
         </rdf:Description>
         <rdf:Description rdf:about="{$file}">
           <rdfs:type>tvepisode</rdfs:type>
         </rdf:Description>
       </xsl:if>
    </xsl:for-each>
    </rdf:RDF>
  </xsl:template>

  <xsl:template match="key" mode="content">
    <xsl:value-of select="following-sibling::*/text()"/>
  </xsl:template>

  <xsl:template match="key" mode="location">
    <xsl:value-of select="concat(substring(following-sibling::*/text(), 1, 7), substring(following-sibling::*/text(), 17))"/>
  </xsl:template>

  <xsl:template match="key" mode="time">
    <!-- since time is in milliseconds we habe to recalculate it -->
    <xsl:variable name="mytime" select="following-sibling::*/text()"/>
    <xsl:value-of select="floor ($mytime div 60000)"/> m
    <xsl:value-of select="floor((($mytime div 60000) - floor ($mytime div 60000)) * 60)"/> s
  </xsl:template>
</xsl:stylesheet>
