<xsl:stylesheet
     xmlns:xsl = "http://www.w3.org/1999/XSL/Transform"
     version = "1.0" >
<xsl:output method="xml" indent="yes" omit-xml-declaration="no" encoding="utf-8" />
<xsl:param name="API_KEY"/>
<xsl:param name="BASE_URI"/>
<xsl:template match="/">
<SearchResults>
  <xsl:for-each select="/OpenSearchDescription/movies/movie">
    <xsl:if test="id and type='movie'">
      <xsl:variable name="URI_WITH_API"><xsl:value-of select="$BASE_URI"/>/<xsl:value-of select="$API_KEY"/></xsl:variable>
      <xsl:variable name="id" select='id' />
      <xsl:variable name="name" select='name' />
      <xsl:variable name="score" select='score' />
      <xsl:variable name="alternative_name" select='alternative_name' />
      <xsl:variable name="type" select='type' />
      <xsl:variable name="imdb_id" select='imdb_id' />
      <xsl:variable name="rating" select='rating' />
      <xsl:variable name="overview" select='overview' />
      <xsl:variable name="released" select='released' />
      <xsl:variable name="subject"><xsl:value-of select='$URI_WITH_API'/>/<xsl:value-of select='$id'/></xsl:variable>
      <SearchResult>
<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
         xmlns:dc="http://purl.org/dc/elements/1.1/"
         xmlns:nie="http://www.semanticdesktop.org/ontologies/2007/01/19/nie#"
         xmlns:nmm="http://www.tracker-project.org/temp/nmm#"
         xmlns:moo="http://www.moovida.com/ontology#">
  <rdf:Description rdf:about="{$subject}">
      <rdf:type rdf:resource="http://www.moovida.com/ontology/Movie" />
  </rdf:Description>
  <rdf:Description rdf:about="{$subject}">
      <nie:title><xsl:value-of select = "$name" /></nie:title>
  </rdf:Description>
  <rdf:Description rdf:about="{$subject}">
      <moo:aka><xsl:value-of select = "$alternative_name" /></moo:aka>
  </rdf:Description>
  <rdf:Description rdf:about="{$subject}">
      <moo:imdbId><xsl:value-of select = "$imdb_id" /></moo:imdbId>
  </rdf:Description>
  <rdf:Description rdf:about="{$subject}">
      <nmm:synopsis><xsl:value-of select = "$overview" /></nmm:synopsis>
  </rdf:Description>
  <rdf:Description rdf:about="{$subject}">
      <dc:date><xsl:value-of select = "$released" /></dc:date>
  </rdf:Description>
  <xsl:for-each select="images/image">
    <xsl:if test="@type = 'poster' and @size = 'original'">
      <xsl:variable name="poster_url" select='@url' />
      <rdf:Description rdf:about="{$subject}">
        <moo:poster rdf:resource="{$poster_url}" />
      </rdf:Description>
    </xsl:if>
    <xsl:if test="@type = 'backdrop' and @size = 'original'">
      <xsl:variable name="backdrop_url" select='@url' />
      <rdf:Description rdf:about="{$subject}">
        <moo:backdrop rdf:resource="{$backdrop_url}" />
      </rdf:Description>
    </xsl:if>
  </xsl:for-each>
</rdf:RDF>
      </SearchResult>
    </xsl:if>
  </xsl:for-each>
</SearchResults>
</xsl:template>
</xsl:stylesheet>
